//Author: BT

var contentArea      = "#contentArea" ;
var headerHeight	 = 115;

var timesIndexed 	 = -1;

/* Volume variables */
var volumeTimer;
var currentVolume	 	 =   0;
var previousVolume	     =   0;
var serverPreviousVolume =  -1;
var volumePollingInterval= 150;

/* The sorted JSON arrays for the current index */
var sortedByArtist;
var sortedByAlbum;	
var sortedByTrack;

function updateProgress(currentPos, trackLength)
{
	var fractionCompleted = (currentPos < 0) ? 0 : ((currentPos > trackLength) ? 1 : (currentPos/trackLength));
	var targetWidth = Math.floor($(".progressBar").width() * fractionCompleted);
	
	//console.log("currentPos: " + currentPos + ", trackLength:" + trackLength + ", fractionCompleted:" + fractionCompleted + ", targetWidth:" + targetWidth);
	
	var progressTimeCurrentMinutes = Math.floor(currentPos/60);
	var progressTimeCurrentSeconds = currentPos%60;
	var progressTimeTotalMinutes   = Math.floor(trackLength/60);
	var progressTimeTotalSeconds   = trackLength%60;	
	
	$(".progressTime").empty().append(
		formatTime(progressTimeCurrentMinutes,progressTimeCurrentSeconds) + " / " + 
		formatTime(progressTimeTotalMinutes,progressTimeTotalSeconds)
	);
	$(".progressBar div").animate({width: targetWidth},1000,'linear');
}

function formatTime(minutes,seconds)
{
	return pad(minutes) + ":" + pad(seconds);
}

//Called when all the elements of the page have finished loading
$(document).ready(function(){
	$('#slider-id').codaSlider({
		dynamicArrows: false,
		autoHeight:false,
		slideEaseDuration: 750,
		firstPanelToLoad: 1
	});
	
	$(".title").hide();
	$(".tab2").hide();
	
	$(contentArea).height($(window).height() - headerHeight);
	$(window).resize(function(){
		$(contentArea).height($(window).height() - headerHeight);
	});
	
	$(".textClass").animate({opacity:0.5},1000);
	
	$(".controls img").hover(
		function(){
			$(this).animate({opacity:1},100);
		},
		function(){
			$(this).animate({opacity:0.5},100);
		}
	);
	
	setInterval(function(){
		getNowPlaying(function(data){
			var nowPlaying = JSON.parse(data);
			populateNowPlaying(nowPlaying);
		});
	}, 1000);
	
	$(".footercontrols span").hover(
		function(){
			$(this).css({'color':'#000'});
		},
		function(){
			if(!$(this).hasClass("footerSelected"))
				$(this).css({'color':'#ccc'});
		}
	);
	
	$('.footercontrols span').click(function(){
		$('.footercontrols span').css({'color':'#ccc'}).removeClass("footerSelected");
		$(this).css({'color':'#000'}).addClass("footerSelected");
	});
	
	$('.footercontrols_bio').click(function(){
		$('.nowplaying_footer div').hide();
		$('.nowplaying_biotext').fadeIn();
	});
	
	$('.footercontrols_similar').click(function(){
		$('.nowplaying_footer div').hide();
		$('.nowplaying_similarartists').fadeIn();
	});
	
	$('.footercontrols_bio').click();
	
	loadTrackIndex(true);
	
	//Set the timesIndexed to -1 so we know it's the first time
	//the client has created the index
	timesIndexed = -1;

	$('.volumeSlider').simpleSlider();
	$('.sliderContainer').animate({"opacity":0}, 0);
	
	var hoverIntentConfig = 
	{
		sensitivity: 3,
		interval: 50,
		timeout: 600,
		over: function(){$('.sliderContainer').animate({"opacity":1}, 50);},
		out: function(){$('.sliderContainer').animate({"opacity":0}, 250);}
	}
	$(".volumeContainer").hoverIntent(hoverIntentConfig);	
	
	//Control functions
	$("img.volumeAdjust").click(function(){
		var currentVolume = $('.volumeSlider')[1].value;
		
		if(currentVolume != 0)
		{
			//Save the current volume, then mute
			previousMutedVol = currentVolume;
			$('.volumeSlider').simpleSlider("setValue", 0);
		}
		else
		{
			//Set the current volume to the previously saved volume.
			$('.volumeSlider').simpleSlider("setValue", previousMutedVol);
		}
	});
	
	$('.volumeSlider').bind("slider:changed", function (event, data) {
		currentVolume = Math.floor(data.value*100);		
	});

	$('img.previousTrack').click(function(){
		sendPreviousTrackCommand();
		setControlIconToPause();
		$(".progressBar div").animate({width: 0},200,'linear');
	});

	$('img.nextTrack').click(function(){
		sendNextTrackCommand();
		setControlIconToPause();
		$(".progressBar div").animate({width: 0},200,'linear');
	});

	setPauseToggleEvent();

	$('img.stopTrack').click(function(){
		sendStopTrackCommand();
		//Set the play/pause control icon immediately to play
		setControlIconToPlay();
	});
	
	volumeTimer = $.timer(function() {
		if(currentVolume != previousVolume)
		{
			previousVolume = currentVolume;
			//console.log("current: " + currentVolume + " , temp: " + sentVolumeValue);
			if(currentVolume != serverPreviousVolume && sentVolumeValue != currentVolume)
			{
				sentVolumeValue = currentVolume;
				sendVolumeCommand(currentVolume);
			}
			setVolumeThumb(currentVolume);
		}
	});

	volumeTimer.set({ time : volumePollingInterval, autostart : true });
	
});

var sentVolumeValue = -1;

//Sets the play/pause toggle icon to the play icon.
function setControlIconToPause()
{
	var srcContainsPause = $("img.playpause").attr("src").indexOf("pause") != -1;
	if(!srcContainsPause)
	{
		$("img.playpause").attr("src", "pause.png");	
	}
}

//Sets the play/pause toggle icon to the play icon.
function setControlIconToPlay()
{
	var srcContainsPause = $("img.playpause").attr("src").indexOf("play") != -1;
	if(!srcContainsPause)
	{
		$("img.playpause").attr("src", "play.png");	
	}
}

//Sets the thumbnail for the volume image based on its relative loudness.
//The thumbnail doesn't change if the volume is in its previous range.
//This is to prevent unnecessary HTTP requests for the same image.
function setVolumeThumb(volume)
{
	var volImg = "audio-";
	
	//Determine which speaker image to use
	if		(volume > 66) volImg += "high.png";
	else if (volume > 33) volImg += "mid.png";
	else if (volume >  0) volImg += "low.png";
	else 			      volImg += "mute.png";
	
	$("img.volumeAdjust").attr("src", volImg);
}

//Resets the toggle event handler for the play/pause control.
//It changes the image of the play/pause control independently
//of what the server tells it. It will be corrected automatically
//if it gets out of sync. The purpose of doing it both client-side
//and server-side is that clients get immediate feedback when they
//click buttons as opposed to having to wait a second for the icon
//to change based on the player's state.
function setPauseToggleEvent()
{
	$('img.playpause').unbind().click(function(){
		var srcContainsPause = $("img.playpause").attr("src").indexOf("pause") != -1;
		var newImg = srcContainsPause ? "play.png" : "pause.png" ;
		$("img.playpause").attr("src", newImg);	
		sendTogglePauseCommand();
	});
	$("img.playpause").hover(
		function(){
			$(this).animate({opacity:1},100);
		},
		function(){
			$(this).animate({opacity:0.5},100);
		}
	);	
}

//Loads the track index into the global parameters. If it's the first time
//the index is called, we set our timesIndexed value to -1 to signal to our
//playerStatus calls that we should sync with the first returned index count.
//Otherwise, we increment our index so that future calls can tell if the index
//needs to be reloaded.
function loadTrackIndex(firstTime)
{
	//Load the track index from the player
	getTrackListing(function(data){
		if(firstTime)
		{
			timesIndexed = -1;
		}

		var trackListing = parseTrackListing(JSON.parse(data));
	
		init(trackListing);
		sortedByArtist 	= sortByArtist(trackListing);
		sortedByAlbum 	= sortByAlbum(trackListing);	
		sortedByTrack 	= sortByTrackName(trackListing);
		
		//Set the default view
		changeView(function(){populateByArtists(contentArea,sortedByArtist)});
		$(".tab1").click(function() {
			$("#query").val("");
			changeView(function(){populateByArtists(contentArea,sortedByArtist)});
		});
		
		$(".tab3").click(function(){
			$('.footercontrols_bio').click();
			clearPreviousResults();
		});
		
		$("#viewArtists").click(function() {
			changeView(function(){populateByArtists(contentArea,sortedByArtist)});
		});

		$("#viewAlbums").click(function() {
			changeView(function(){populateByAlbums(contentArea,sortedByAlbum)});
		});

		$("#viewTracks").click(function() {
			changeView(function(){populateByTracks(contentArea,sortedByTrack)});
		});		

		$("#query").bind('input', function() {
			populateQueryResults($("#query").val(), sortedByArtist,sortedByAlbum,sortedByTrack);
		});
		
		//Clear the previous search results when the headings are clicked 
		$(".coda-nav ul li a").click(function() {
			clearPreviousResults();
		});
		
		//Cause the headers in now playing to be refreshed by setting the current track ID to -1
		previousTrackId = -1;
	});
}

function changeView(viewFunction)
{
	$(contentArea).empty().hide();
	viewFunction();
	$(contentArea).fadeIn();
}

function getTrackListing(callback)
{ 
	$.ajax({
		type:"POST",
		url: 'trackList',
		// url: 'tracks.txt', 
		success: function(data){undoError();callback(data);},
		error: function(){doError();},
		cache: false
	});
}

//Testing variable for switching between two returned JSON objects for the playerStatus API call.
var mod = 0;

function getNowPlaying(callback)
{
	// if(mod == 0)
	// {
		// callback('{"currentPosition":50, "trackID":14, "next":10, "previous":9, "paused":1, "stopped": 1, "timesIndexed":2,"volume":' + currentVolume + '}');
		// mod = 1;
	// }
	// else
	// {
		// callback('{"currentPosition":50, "trackID":14, "next":10, "previous":9, "paused":0, "stopped": 0, "timesIndexed":2,"volume":' + currentVolume + '}');
		// mod = 0;
	// }
	$.ajax({
		type:"POST",
		url: 'playerStatus',
		// url: 'nowplaying.txt', 
		success: function(data){undoError();callback(data);},
		error: function(){doError();},
		cache: false
	});
}

function doError()
{
	// $('#pageContainer').animate({opacity:'0.2'},1000);
	// $('.error').fadeIn();
}

function undoError()
{
	// $('#pageContainer').animate({opacity:'1'},1000);
	// $('.error').fadeOut();
}

/*
 * parseTrackListing
 *
 * Takes a JSON respose from the MP3 player, sorts the data,
 * and returns a hierchicial object organized by artist,
 * album, and track number.
 */
function parseTrackListing(masterIndex)
{
	//Sort tracks by Artist, Album, Track Number (in that order)
	masterIndex.tracks = masterIndex.tracks.sort(function(a,b){
		var firstValue  = a.artist+a.album+pad(a.track);
		var secondValue = b.artist+b.album+pad(b.track);
		return compareItems(firstValue, secondValue);	
	});

	//Group by artist
	var artistGrouping = new Object();
	$.each(masterIndex.tracks,function(index, value){
		var currentArtist 	= value.artist;
		var allArtistTracks = $.grep(masterIndex.tracks, function(elem){
			return elem.artist == currentArtist;
		});
		
		if(artistGrouping[currentArtist] == undefined){
			artistGrouping[currentArtist] = allArtistTracks;
		}
	});
	
	//Group into albums for each artist
	var fullyGrouped = new Object();
	$.each(artistGrouping, function(artistName, tracks){
		tracks.forEach(function(track){
			if(fullyGrouped[artistName] == undefined){
				fullyGrouped[artistName] = new Object();
			}
			
			if(fullyGrouped[artistName][track.album] == undefined){
				fullyGrouped[artistName][track.album] = getAlbumTracks(tracks, track.album);
			}
		});
	});
	
	return fullyGrouped;	
}

function sortByArtist(trackListing)
{
	var sortedByArtist = new Array();
	$.each(trackListing, function(artistName, albums){
		sortedByArtist.push({artist:artistName, albums:albums}); 		
	});
	
	sortedByArtist = sortedByArtist.sort(function(a,b){
		return compareItems(a.artist, b.artist);		
	});
	
	return sortedByArtist;
}

function sortByAlbum(trackListing)
{
	var sortedByAlbum = new Array();
	$.each(trackListing, function(artistName, albums){
		$.each(albums, function(albumName, tracks){
			sortedByAlbum.push({album:albumName, artist:artistName, tracks:tracks}); 		
		});
	});
	
	sortedByAlbum = sortedByAlbum.sort(function(a,b){
		return compareItems(a.album, b.album);	
	});
	
	return sortedByAlbum;
}

function sortByTrackName(trackListing)
{
	var sortedByTrackName = new Array();
	$.each(trackListing, function(artistName, albums){
		$.each(albums, function(albumName, tracks){
			$.each(tracks, function(trackIndex, track){
				sortedByTrackName.push(track); 
			});	
		});
	});
	
	sortedByTrackName = sortedByTrackName.sort(function(a,b){
		return compareItems(a.title, b.title);	
	});
	
	return sortedByTrackName;
}

//Performs a greater-than comparison for sorting in ascending order.
function compareItems(value1, value2)
{
	return (value1 < value2) ? -1 : (value1 > value2) ? 1 : 0 ;	
}

function getAlbumTracks(artistObject, albumTitle)
{
	//Get all the tracks in an artist's array that come from
	//a given album
	var allAlbumTracks = $.grep(artistObject, function(elem){
		return elem.album == albumTitle;
	});
	return allAlbumTracks;
}

function getArtistAlbums(artist)
{
	//Get all the albums from an artist
	//a given album
	var artist = sortedByArtist.filter(
		function(element,index,array){
		return element.artist == artist;
	});
	return artist[0].albums;
}

function getAlbumObject(artist, album)
{
	//Get a specific album
	var album = sortedByAlbum.filter(
		function(element,index,array){
		return element.artist == artist && element.album == album;
	});
	return album[0];
}

function getTrackById(id)
{
	//Get all the tracks in an artist's array that come from
	//a given album
	var track = sortedByTrack.filter(
		function(element,index,array){
		return element.id == id;
	});

	return track[0];
}


