//Author: BT

var queryResultsArea = "#contentArea";

var artistResults, albumResults, trackResults;

function clearPreviousResults()
{
	artistResults = new Array();
	albumResults  = new Array(); 
	trackResults  = new Array();
}

function populateQueryResults(query, sortedByArtist,sortedByAlbum,sortedByTrack)
{
	if(!$(".tab1 a").hasClass("current"))
	{
		$(".tab1").click();
		$("#query").val(query);
	}
	
	if(query == "")
	{
		$(queryResultsArea).empty();
		clearPreviousResults();
		populateByArtists(queryResultsArea, sortedByArtist);
		$("#viewTypeSelector").animate({opacity:"1"},0);
		return;
	}

	//In case we were viewing an album when the query was invoked, hide the back button
	$("#back").hide();
	
	//First ranks begin with the search term
	newArtistResults = sortedByArtist.filter(
		function(element,index,array){
		return firstRankQueryMatched(element.artist, query);
	});
	
	newAlbumResults = sortedByAlbum.filter(
		function(element,index,array){
		return firstRankQueryMatched(element.album, query);
	});	
	
	newTrackResults = sortedByTrack.filter(
		function(element,index,array){
		return firstRankQueryMatched(element.title, query);
	});
	
	if(query.length < 3 && newArtistResults.length == 0 && newAlbumResults.length == 0 && newTrackResults.length == 0)
	{
		printNoResults();
		clearPreviousResults();
	}
	else if(query.length >= 3)
	{
		var secondRankArtists = sortedByArtist.filter(
			function(element,index,array){
			return secondRankQueryMatched(element.artist, query);
		});
		
		var secondRankAlbums = sortedByAlbum.filter(
			function(element,index,array){
			return secondRankQueryMatched(element.album, query);
		});	
		
		var secondRankTracks = sortedByTrack.filter(
			function(element,index,array){
			return secondRankQueryMatched(element.title, query);
		});
		
		secondRankArtists.forEach(function(value, index){
			if(!newArtistResults.contains(value))
			{
				newArtistResults.push(value);
			}
		});
		
		secondRankAlbums.forEach(function(value, index){
			if(!newAlbumResults.contains(value))
			{		
				newAlbumResults.push(value);
			}
		});

		secondRankTracks.forEach(function(value, index){
			if(!newTrackResults.contains(value))
			{		
				newTrackResults.push(value);
			}
		});
	}

	if( !arraysEqual(newArtistResults,artistResults) ||
		!arraysEqual(newAlbumResults,albumResults)   ||
		!arraysEqual(newTrackResults,trackResults)     )
	{
		trackResults  = newTrackResults;
		artistResults = newArtistResults;
		albumResults  = newAlbumResults;

		$(queryResultsArea).empty();
		
		if(artistResults.length == 0 && albumResults.length == 0 && trackResults.length == 0)
		{
			printNoResults();
		}
		
		//$(contentArea).append("<div class='queryClassHeading'>Search results for " + query + "</div>");
		if(artistResults.length != 0)
		{
			$(contentArea).append("<div class='queryClassHeading'>Artists</div><br />");
			//$(contentArea).append("<div class='queryClassHeading'>Artists (" + artistResults.length + ")</div><br />");
			populateByArtists(queryResultsArea, artistResults);
		}
		
		if(albumResults.length != 0)
		{		
			$(contentArea).append("<div class='queryClassHeading'>Albums</div>");
			//$(contentArea).append("<div class='queryClassHeading'>Albums (" + albumResults.length + ")</div>");
			populateByAlbums(queryResultsArea, albumResults);
		}
		
		if(trackResults.length != 0)
		{
			$(contentArea).append("<div class='queryClassHeading'>Tracks</div>");
			//$(contentArea).append("<div class='queryClassHeading'>Tracks (" + trackResults.length + ")</div>");
			//populateByTracks(queryResultsArea, trackResults);
			populateByTracks_AlbumCovers(queryResultsArea, trackResults);
		}
	}
	//Sometimes the arrays will be equal, which means we shouldn't change the results. But if their sizes are all 0,
	//then they're equal because there were no results. In that case, we should still push the no results string.
	else if(artistResults.length == 0 && albumResults.length == 0 && trackResults.length == 0)
	{
		printNoResults();
	}
	
	$("#contentHeader").hide();
	//$("#viewTypeSelector").animate({opacity:"0"},50);
	$("#viewTypeSelector").hide();
}

Array.prototype.contains=function(item)
{
  return this.indexOf(item) != -1;
}

function printNoResults()
{
	$(contentArea).empty().append("<div class='queryClassHeading'>No search results.</div><br />");
}

function firstRankQueryMatched(value, query)
{
	return value.toLowerCase().indexOf(query.toLowerCase()) == 0;
}

function secondRankQueryMatched(value, query)
{
	return value.toLowerCase().indexOf(query.toLowerCase()) != -1;
}

function arraysEqual(a1,a2) {
    return JSON.stringify(a1)==JSON.stringify(a2);
}