//Author: BT

var lastFMApiKey 	= "8c044eac1cee75d3796a7736138d727f";
var NAV_IMAGE_SIZE 	= 2; //2 Corresponds to a 174x174px album cover as per lastFM's API

function init(trackListing)
{
	sortedByArtist 	= sortByArtist(trackListing);
	sortedByAlbum 	= sortByAlbum(trackListing);	
	sortedByTrack 	= sortByTrackName(trackListing);
}

//Clears the content area and calls the function to restore state
function configureGoBack(callback)
{
	$("#back").unbind();
	$("#back").click(function() {
		$(contentArea).empty();
		callback();
	});
	$("#viewTypeSelector").animate({opacity:"100"},0);
}

//Loads all artists into the content area.
//Each artist's first album is used as the thumbnail image.
function populateByArtists(contentArea, objectData)
{
	$("#viewTypeSelector").show();
	$(".viewType").removeClass("selectedView");
	$("#viewArtists").addClass("selectedView");
	
	$("#back").hide();
	$("#contentHeader").empty();
	
	objectData.forEach(function(value, index){
		var albumTitle;
		for(property in value.albums){
			albumTitle = property;
			break;
		}

		var divId = getThumbnailDivId(value.artist, albumTitle);
		var thumbnailMarkup = getThumbnailMarkupArtist(value.artist, getPropertySize(value.albums), divId);		
		$(contentArea).append(thumbnailMarkup);
	
		//Set the action for clicking on an artist
		$(".thumb_" + divId + ".artistThumb").click(function() {
			populateArtistAlbums(contentArea, value.artist,value.albums);
			clearPreviousResults();
		});		
		
		getAlbumCover(value.artist, albumTitle, function(data){
			setAlbumCover(data,divId);
		});
	});
}

//Called when an artist is clicked. Populates the content area with the particular
//artist's albums
function populateArtistAlbums(contentArea, artist, objectData)
{
	configureGoBack(function(){populateByArtists(contentArea, sortedByArtist);});
	
	if($("#contentHeader").text() == "")
	{
		$("#contentHeader").hide().append("<span class='artistCrumb heading_artist'>" + artist + "</span>").fadeIn();
	}
	else
	{
		$("#contentHeader span:not(.artistCrumb)").fadeOut();
	}
	
	$("#viewTypeSelector").hide();
	$("#back").fadeIn();
	
	//var albumNum = getPropertySize(objectData);
	
	$(contentArea).empty();
	
	getArtistInfo(artist, function(data){
		if (navigator.userAgent.indexOf("Firefox")!= -1)
		{
			data = JSON.parse(data);
		}
		var bioString;
		
		if(data.message) //This child will exist if there was an error getting the artist from the API
		{
			bioString = "Not available.";
		}
		else
		{
			bioString = data.artist.bio.summary.replace(/<a(\s[^>]*)?>(.*?)<\/a>/ig, '$2');
			bioString = bioString.replace(/\(\.\.\.\)/g, '');
			var lastFMPlug = bioString.indexOf("Read more about");
			bioString = bioString.substr(0,lastFMPlug);
		}
		
		var imgMarkup = "";
		if(!data.message)
		{
			imgMarkup = "<img align=left src='" + data.artist.image[3]['#text'] + "'>";
		}
		
		$(contentArea).append("<div class='artistSummary'>" + 
								imgMarkup +
								"<h1>Background</h1><span>" + bioString + "<br /></span>" + 
								"</div>");
	});
	
	$.each(objectData, function(album, tracks){
		var divId = getThumbnailDivId(album, artist);
		var thumbnailMarkup = getThumbnailMarkupAlbum(artist, album, tracks.length, divId, false);
		$(contentArea).append(thumbnailMarkup);
		
		//Set the action for clicking on an album
		$(".thumb_" + divId + ".albumThumb").click(function() {
			populateSingleAlbum(contentArea, artist, objectData, tracks);
			clearPreviousResults();
		});
		
		getAlbumCover(artist, album, function(data){
			setAlbumCover(data,divId);
		});
		
		// if(albumNum == 1)
		// {
			// $(".thumb_" + divId).click();
		// }
	});
}

//Called when an album is clicked from browsing via artist navigation. 
//We need to change the back button because it's 2 levels deep, as opposed
//to other navigation methods, which are only one level deep.
function populateSingleAlbum(contentArea, artist, previousObjectData, value)
{
	configureGoBack(function(){populateArtistAlbums(contentArea, artist, previousObjectData);});
	$(".artistCrumb").unbind().click(function() {
		$(contentArea).empty();
		populateArtistAlbums(contentArea, artist, previousObjectData);
	});
	
	loadAlbumData(contentArea, artist, value);
}

//Entry point for pushing album data to the content area. Back buttons have been set.
function loadAlbumData(contentArea, artist, album)
{
	//Clear previous search results so that typing in the search box while viewing an album,
	//even if the results are the same as the ones that took the user to the album,
	//brings the user back to the search state.
	clearPreviousResults();
	
	$("#viewTypeSelector").hide();
	$("#back").fadeIn();
	$("#contentHeader").show();
	if($("#contentHeader").text() == "")
	{
		$("#contentHeader").append("<span class='artistCrumb'>" + artist + "</span>");
	}
	
	var albumTitleMarkup = " <span class='heading_album'>" + album[0].album + "</span>";
	$(".heading_album").empty();
	$("#contentHeader").append(albumTitleMarkup);
	$(".heading_album").fadeIn();
	
	$(contentArea).empty();

	var trackMarkup = 	"<div class='trackListing'>" +
							"<div class='trackListingImg'><img src='placeholder.png' width='300' height='300'></div>";
	
	var trackDivs = new Array();
	trackDivs.push("<div class='trackListingTracks'>");
	var colNo = 0;
	
	album.forEach(function(track, index){
		if(index == 11)
		{
				trackDivs[colNo] += "</div>";
				trackDivs.push("<div class='trackListingTracks'>");
				colNo++;
		}
		
		trackDivs[colNo] += "<div id='track" + track.id + "' class='track'>" +
							"<span class='trackNumber'>" + track.track + "</span> " + 
							"<span class='trackTitle'>"  + track.title + "</span> " +
							"<span class='trackLength'>" + pad(Math.floor(track.length/60)) + ":" + pad(track.length%60) + "</span> " +
						"</div>";
	});
	
	trackDivs[colNo] += "</div>";
	
	for(var i=0; i<=colNo; i++)
	{
		trackMarkup += trackDivs[i];
	}
	trackMarkup += "</div>";
	
	if(colNo == 0)
	{
		trackMarkup += "<div class='trackListingTracks'></div>";
	}
	
	$(contentArea).append(trackMarkup);
	
	//Set behavior for clicking on tracks
	configureTrackClicks();
		
	getAlbumCover(artist, album[0].album, function(data){
		var currentUrl = $(".trackListing img").attr("src");
		var potentialUrl = getLargeAlbumUrl(data);
		if(potentialUrl != currentUrl)
		{
			$(".trackListing img").attr("src", getLargeAlbumUrl(data));
			$(".trackListing img").attr("width", "300");
			$(".trackListing img").attr("height", "300");
		}
	});
}

function pad(n){
    return n > 9 ? "" + n: "0" + n;
}

//Loads all albums into a content area.
function populateByAlbums(contentArea, objectData, length)
{
	$("#viewTypeSelector").show();
	$(".viewType").removeClass("selectedView");
	$("#viewAlbums").addClass("selectedView");
	
	$("#contentHeader").empty();
	$("#back").hide();
	
	configureGoBack(function(){populateByAlbums(contentArea, objectData, length );});
	objectData.forEach(function(value, index){
		var divId = getThumbnailDivId(value.album, value.artist);
		//if(length == undefined)
		//{
			length = value.tracks.length;
		//}
		var thumbnailMarkup = getThumbnailMarkupAlbum(value.artist, value.album, length, divId, true);			
		$(contentArea).append(thumbnailMarkup);

		//Set the action for clicking on an album
		$(".thumb_" + divId + ".albumThumb").click(function() {
			loadAlbumData(contentArea, value.artist, value.tracks);
		});		
		
		getAlbumCover(value.artist, value.album, function(data){
			setAlbumCover(data,divId);
		});
	});
}

//Loads all tracks into a content area.
function populateByTracks(contentArea, objectData)
{
	$(".viewType").removeClass("selectedView");
	$("#viewTracks").addClass("selectedView");	
	
	clearPreviousResults();
	
	var trackMarkup = "";
	objectData.forEach(function(value, index){
			trackMarkup += "<p id='track" + value.id + "' class='track'>" +
								"<span class='trackNumber'>" + value.artist + "</span> " + 
								"<span class='trackTitle'>"  + value.title + "</span> " +
								"<span class='trackAlbum'>("  + value.album + ")</span> " +
							"</p>";								
	});
	
	$(contentArea).append(trackMarkup);
	configureTrackClicks();
}

//Sets click handler for newly appended .track class elements.
//Clicking them will send the play command to the player and 
//then go to the now playing screen.
function configureTrackClicks()
{
	$('.track').click(function(){
		var trackNumber = parseInt($(this).attr("id").substr(5));
		sendPlayCommand(trackNumber);
		$(".tab3").click();
	});		
}

function populateByTracks_AlbumCovers(contentArea, objectData)
{
	objectData.forEach(function(value, index){
		//getAlbumCover(value.artist, value.album, function(data){
			var divId = getThumbnailDivId(value.artist, value.album);
			var thumbnailMarkup = getThumbnailMarkupTrack(value.artist, value.album, value.title, divId);
			$(contentArea).append(thumbnailMarkup);			
			getAlbumCover(value.artist, value.album, function(data){
				setAlbumCover(data,divId);
			});
			
			//Set behavior for clicking on tracks
			$(".thumb_" + divId + ".trackThumb").click(function(){
				sendPlayCommand(value.id);
				$('.tab3').click();
			});			
			
		//});
	});
}

function getAlbumCover(artist, album, callback)
{ 
    $.get
	(	"http://ws.audioscrobbler.com/2.0/?method=album.getinfo&api_key=" + lastFMApiKey +
			"&artist=" + artist + 
			"&album="  + album +
			"&format=json", 
		  callback
	);
}

function getArtistInfo(artist, callback)
{ 
    $.get
	(	"http://ws.audioscrobbler.com/2.0/?method=artist.getinfo&api_key=" + lastFMApiKey +
			"&artist=" + artist +
			"&format=json", 
		  callback
	).fail(function(){callback(JSON.parse('{"message":"error"}'))});
	
	// $.ajax({
		// url: "http://ws.audioscrobbler.com/2.0/?method=artist.getinfo&api_key=" + lastFMApiKey +
				// "&artist=" + artist +
				// "&format=json", 
		// success: callback,
		// error: function(){callback('{"data":{"message":"error"}}'},
		// cache: false
	// });	
}

function setAlbumCover(data, divId)
{
	if (navigator.userAgent.indexOf("Firefox")!= -1)
	{
		data = JSON.parse(data);
	}
	if(data.album == undefined)
	{
		return;
	}
	
	if(data.album.image[NAV_IMAGE_SIZE]['#text'] != undefined){
		//In some cases, there's an entry on lastFM but there's no URL for the 
		//album cover. We need to consider that case here.
		var coverUrl = data.album.image[NAV_IMAGE_SIZE]['#text'];
		if(coverUrl != "")
		{
			setThumbSource(divId, coverUrl);
		}
	}
}

function getLargeAlbumUrl(data)
{
	if (navigator.userAgent.indexOf("Firefox")!= -1)
	{
		data = JSON.parse(data);
	}
	if(data.album == undefined)
	{
		return "placeholder.png";
	}
	var coverUrl = data.album.image[3]['#text'];
	if(coverUrl != undefined){
		if(coverUrl == "")
		{
			return "placeholder.png";
		}
		else
		{
			return data.album.image[3]['#text'];
		}
	}
}

function getPropertySize(obj)
{
	var count = 0;
	for(property in obj)
	{
		count++;
	}
	return count;
}

function getThumbnailMarkupGeneric(divId, extraClass, description)
{
	return	"<div class='thumb_" + divId +" thumbnail"+ extraClass +"'>" +
				"<img src='placeholder.png' height='174' width='174'>" +
				"<p class='thumbnailDescription'>"+ description +
			"</p></div>";	
}

function getThumbnailMarkupAlbum(artist, album, trackNo, divId, includeArtist)
{
	var artistString = includeArtist ? (artist + "<br>") : "";
	var plural = trackNo > 1 ? "s" : "";
	return	getThumbnailMarkupGeneric(
				divId, 
				" albumThumb", 
				"<span class='thumbnailDesc_artist'>" + artistString + "</span>" + 
				"<span class='thumbnailDesc_album'>" + album + "</span><br />" + 
				"<span class='thumbnailDesc_number'>(" + trackNo + " track" + plural + ")</span>"
			);
}

function getThumbnailMarkupArtist(artist, albumNum, divId)
{
	var plural = albumNum > 1 ? "s" : "";
	return	getThumbnailMarkupGeneric(
				divId,
				" artistThumb",
				"<span class='thumbnailDesc_artist'>" + artist + "</span><br />" +
				"<span class='thumbnailDesc_number'>(" + albumNum + " album" + plural + ")</span>"
			);
}

function getThumbnailMarkupTrack(artist, album, title, divId)
{
	return	getThumbnailMarkupGeneric(
				divId,
				" trackThumb",
				"<span class='thumbnailDesc_artist'>" + artist + "</span><br />" +
				"<span class='thumbnailDesc_album'>"  + album + "</span><br />" +
				"<span class='thumbnailDesc_title'>"  + title + "</span>"
			);
}

//Generate a div id for a thumbnail. We just concatenate 
//artist and album and remove the spaces to keep legal HTML.
function getThumbnailDivId(artist, album)
{
	return (artist + album).replace(/\W/g, '');
}

//Changes the source image of a given div id
function setThumbSource(divId, newSrc)
{
	$(".thumb_" + divId + " img").attr("src", newSrc);
	$(".thumb_" + divId + " img").addClass("coverArt");
}